/* Teknisa - Tecnologia em Informtica

Nome: 3908_CDPFUNO_CUSTO_MPRIMAINSUMO.SQL

Descrio:
Funo para retornar o custo do produto (Mat. Prima/Insumo).

Criao:
17/05/2005 - Fabrcio Marcelo da Silva

@..\Sql\End_Conv\Oracle\3908_CDPFUNO_CUSTO_MPRIMAINSUMO.SQL
*/

CREATE OR REPLACE FUNCTION CUSTO_MPRIMAINSUMO(
   P_CDFILIAL      IN FILIAL.CDFILIAL%TYPE,
   P_CDPRODUTO     IN PRODUTO.CDPRODUTO%TYPE,
   P_CDPROCFABRIC  IN TPROCFABRICA.CDPROCFABRIC%TYPE,
   P_TIPOCUSTO     IN INTEGER,
   P_QTDE          IN FLOAT,
   P_DTCUSTO       IN DATE) RETURN FLOAT IS

   V_VRCUSTMPRIMA    FLOAT;
   V_VRCUSTINSUMO    FLOAT;
   V_VRCUSTPROD      FLOAT;
   V_QTDE            FLOAT;
   V_COUNTSACAB      NUMBER;
BEGIN
   V_VRCUSTMPRIMA  := 0;
   V_VRCUSTINSUMO  := 0;
   V_VRCUSTPROD    := 0;
   V_COUNTSACAB    := 0;
   V_QTDE          := P_QTDE;

   IF V_QTDE = 0 THEN 
      V_QTDE := 1;
   END IF;
   /* Verifica semi-acabados */
   IF (NOT P_CDPROCFABRIC IS NULL) THEN
      SELECT
         COUNT(I.CDPRODINSUMO)
      INTO
         V_COUNTSACAB
      FROM
         INSUMETAPA I,
         PROCFABRICA P
      WHERE
         (I.CDFILIAL     = P_CDFILIAL)     AND
         (I.CDPRODUTO    = P_CDPRODUTO)    AND
         (I.CDPROCFABRIC = P_CDPROCFABRIC) AND
         (I.IDSEMIACETAP = 'S')            AND
         (I.CDFILIAL     = P.CDFILIAL)     AND
         (I.CDPRODINSUMO = P.CDPRODUTO)    AND
         (P.IDPROFABPADR = 'S');

      IF V_COUNTSACAB > 0 THEN

         FOR C_SEMIACABADO IN
            (SELECT
                I.CDPRODUTO,
                I.CDPRODINSUMO,
                P.CDPROCFABRIC,
                P.IDPROFABPADR,
                QTPREVI_MATPRIMA(P_CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, P_QTDE) AS QUANTIDADE
             FROM
                INSUMETAPA I,
                PROCFABRICA P
             WHERE
                (I.CDFILIAL     = P_CDFILIAL)     AND
                (I.CDPRODUTO    = P_CDPRODUTO)    AND
                (I.CDPROCFABRIC = P_CDPROCFABRIC) AND
                (I.IDSEMIACETAP = 'S')            AND
                (I.CDFILIAL     = P.CDFILIAL)     AND
                (I.CDPRODINSUMO = P.CDPRODUTO)    AND
                (P.IDPROFABPADR = 'S')
            )
         LOOP
            V_COUNTSACAB := 0;

            SELECT
               COUNT(I.CDPRODINSUMO)
            INTO
               V_COUNTSACAB
            FROM
               INSUMETAPA I,
               PROCFABRICA P
            WHERE
               (I.CDFILIAL     = P_CDFILIAL)     AND
               (I.CDPRODUTO    = P_CDPRODUTO)    AND
               (I.CDPROCFABRIC = P_CDPROCFABRIC) AND
               (I.IDSEMIACETAP = 'S')            AND
               (I.CDFILIAL     = P.CDFILIAL)     AND
               (I.CDPRODINSUMO = P.CDPRODUTO)    AND
               (P.IDPROFABPADR = 'S');

            IF V_COUNTSACAB > 0 THEN
               V_VRCUSTMPRIMA := 0;

               SELECT
                  (SUM(QTPREVI_MATPRIMA(P_CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, P_QTDE) *
                   CUSTO_PRODUTO(P_CDFILIAL, I.CDPRODINSUMO, P_TIPOCUSTO, P_DTCUSTO, P_DTCUSTO) / V_QTDE))
               INTO
                  V_VRCUSTMPRIMA
               FROM
                  INSUMETAPA I
               WHERE
                  (I.CDFILIAL     = P_CDFILIAL)     AND
                  (I.CDPRODUTO    = P_CDPRODUTO)    AND
                  (I.CDPROCFABRIC = P_CDPROCFABRIC) AND
                  (NVL(I.IDSEMIACETAP,'N') <> 'S');

               V_VRCUSTPROD := V_VRCUSTPROD + V_VRCUSTMPRIMA + (CUSTO_MPRIMAINSUMO(P_CDFILIAL,C_SEMIACABADO.CDPRODINSUMO,C_SEMIACABADO.CDPROCFABRIC,P_TIPOCUSTO,C_SEMIACABADO.QUANTIDADE,P_DTCUSTO) * C_SEMIACABADO.QUANTIDADE / V_QTDE);
            ELSE
               V_VRCUSTINSUMO := 0;

               SELECT
                  (SUM(QTPREVI_MATPRIMA(P_CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, C_SEMIACABADO.QUANTIDADE) *
                   CUSTO_PRODUTO(P_CDFILIAL, I.CDPRODINSUMO, P_TIPOCUSTO, P_DTCUSTO, P_DTCUSTO) / C_SEMIACABADO.QUANTIDADE))
               INTO
                  V_VRCUSTINSUMO
               FROM
                  INSUMETAPA I
               WHERE
                  (I.CDFILIAL     = P_CDFILIAL)                  AND
                  (I.CDPRODUTO    = C_SEMIACABADO.CDPRODINSUMO)  AND
                  (I.CDPROCFABRIC = C_SEMIACABADO.CDPROCFABRIC);

               V_VRCUSTPROD := V_VRCUSTPROD + V_VRCUSTINSUMO;
            END IF;
         END LOOP;
      ELSE
         V_VRCUSTINSUMO := 0;

         SELECT
            (SUM(QTPREVI_MATPRIMA(P_CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, P_QTDE) *
             CUSTO_PRODUTO(P_CDFILIAL, I.CDPRODINSUMO, P_TIPOCUSTO, P_DTCUSTO, P_DTCUSTO)) / V_QTDE)
         INTO
            V_VRCUSTINSUMO
         FROM
            INSUMETAPA I
         WHERE
            (I.CDFILIAL     = P_CDFILIAL)      AND
            (I.CDPRODUTO    = P_CDPRODUTO)     AND
            (I.CDPROCFABRIC = P_CDPROCFABRIC);

         V_VRCUSTPROD := V_VRCUSTINSUMO;
      END IF;
   ELSE
      /* Verifica matria-prima */
      V_VRCUSTMPRIMA := 0;

      SELECT
         MAX(CUSTO_PRODUTO(P_CDFILIAL, P_CDPRODUTO, P_TIPOCUSTO, P_DTCUSTO, P_DTCUSTO))
      INTO
         V_VRCUSTMPRIMA
      FROM DUAL;

      V_VRCUSTPROD := V_VRCUSTMPRIMA;
   END IF;

   RETURN(V_VRCUSTPROD);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CUSTO_MPRIMAINSUMO','4.09.031'); END;
/

