/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ECTF                                                     */
/* Tabela : EMPRCNTRFIL                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ECTF'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ECTF
GO

CREATE TRIGGER DTULTATU_ECTF
ON EMPRCNTRFIL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'EMPRCNTRFIL', CDFILIAL, 'CDFILIAL='   + CDFILIAL + ';' +
                                                'CDEMPRESA='  + CDEMPRESA+ ';' +
                                                'CDINSCESTA=' + CDINSCESTA, GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE EMPRCNTRFIL
      SET DTULTATUECTF = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(EMPRCNTRFIL.CDINSCESTA,0) = ISNULL(INSERTED.CDINSCESTA,0)) AND
            (ISNULL(EMPRCNTRFIL.CDINSCMUNI,0) = ISNULL(INSERTED.CDINSCMUNI,0)) AND
            (ISNULL(EMPRCNTRFIL.CDEMPRESA,0)  = ISNULL(INSERTED.CDEMPRESA,0))  AND
            (ISNULL(EMPRCNTRFIL.CDFILIAL,0)   = ISNULL(INSERTED.CDFILIAL,0))   AND
            (ISNULL(EMPRCNTRFIL.CDSERIE,0)    = ISNULL(INSERTED.CDSERIE,0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ECTF','5.60.XXX';
GO
