CREATE TABLE CONSISTORCAMENTO (
  NRCONSISTORCAMENTO NUMBER(10) NOT NULL, 
  CDFILDEST VARCHAR2(4) NOT NULL, 
  CDFILLANC VARCHAR2(4) NOT NULL, 
  NRDEMANDA VARCHAR2(10) NOT NULL, 
  IDTPDEMANDA VARCHAR2(30) NOT NULL, 
  DTDEMANDA DATE DEFAULT NULL NULL, 
  CDPRODUTO VARCHAR2(10) NOT NULL, 
  VRORCAMENTO NUMBER(10) DEFAULT NULL NULL, 
  VRSOLICITADO NUMBER(10) DEFAULT NULL NULL, 
  DSERROCONSORCA VARCHAR2(200) DEFAULT NULL NULL, 
  NRORG NUMBER(10) DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT 1 NULL, 
  NRORGULTATU NUMBER(10) DEFAULT 1 NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1' NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT '1' NULL,
  CONSTRAINT PK_CONSISTORCAMENTO PRIMARY KEY(NRCONSISTORCAMENTO)
)
/
ALTER TABLE CONSISTORCAMENTO ADD CONSTRAINT CKC_IDTPDEMANDA_CONSISTORCA CHECK (IDTPDEMANDA IN ('SOLICITACAO', 'AF', 'PEDIDOOL'))
/
ALTER TABLE CONSISTORCAMENTO ADD CONSTRAINT CKC_IDATIVO_CONSISTORCAMENTO CHECK (IDATIVO IN ('S','N'))
/
CREATE INDEX CONSISTORCAMENTO_01 ON CONSISTORCAMENTO (CDFILDEST ASC, CDFILLANC ASC, NRDEMANDA ASC, IDTPDEMANDA ASC)
/
ALTER TABLE CONSISTORCAMENTO ADD CONSTRAINT FKGOP00716PRODUTO FOREIGN KEY (CDPRODUTO) REFERENCES PRODUTO (CDPRODUTO)
/
CREATE INDEX FKGOP00716PRODUTO ON CONSISTORCAMENTO (CDPRODUTO ASC)